Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/UIActionPoolSelector.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/UIActionPoolSelector.cpp	(revision 42766)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/UIActionPoolSelector.cpp	(revision 42767)
@@ -630,11 +630,11 @@
 
 
-class UIActionMenuMachineClose : public UIActionMenu
-{
-    Q_OBJECT;
-
-public:
-
-    UIActionMenuMachineClose(QObject *pParent)
+class UIActionMenuClose : public UIActionMenu
+{
+    Q_OBJECT;
+
+public:
+
+    UIActionMenuClose(QObject *pParent)
         : UIActionMenu(pParent, ":/exit_16px.png")
     {
@@ -759,4 +759,7 @@
     m_pool[UIActionIndexSelector_Simple_Group_Remove] = new UIActionSimpleGroupRemove(this);
     m_pool[UIActionIndexSelector_Simple_Group_Sort] = new UIActionSimpleGroupSort(this);
+    m_pool[UIActionIndexSelector_Simple_Group_Close_Save] = new UIActionSimpleSave(this);
+    m_pool[UIActionIndexSelector_Simple_Group_Close_ACPIShutdown] = new UIActionSimpleACPIShutdown(this);
+    m_pool[UIActionIndexSelector_Simple_Group_Close_PowerOff] = new UIActionSimplePowerOff(this);
 
     /* 'Machine' actions: */
@@ -765,4 +768,7 @@
     m_pool[UIActionIndexSelector_Simple_Machine_Remove] = new UIActionSimpleMachineRemove(this);
     m_pool[UIActionIndexSelector_Simple_Machine_AddGroup] = new UIActionSimpleMachineAddGroup(this);
+    m_pool[UIActionIndexSelector_Simple_Machine_Close_Save] = new UIActionSimpleSave(this);
+    m_pool[UIActionIndexSelector_Simple_Machine_Close_ACPIShutdown] = new UIActionSimpleACPIShutdown(this);
+    m_pool[UIActionIndexSelector_Simple_Machine_Close_PowerOff] = new UIActionSimplePowerOff(this);
 
     /* Common actions: */
@@ -777,9 +783,4 @@
     m_pool[UIActionIndexSelector_Simple_Common_CreateShortcut] = new UIActionSimpleCommonCreateShortcut(this);
     m_pool[UIActionIndexSelector_Simple_Common_SortParent] = new UIActionSimpleCommonSortParent(this);
-
-    /* 'Machine/Close' actions: */
-    m_pool[UIActionIndexSelector_Simple_Machine_Close_Save] = new UIActionSimpleSave(this);
-    m_pool[UIActionIndexSelector_Simple_Machine_Close_ACPIShutdown] = new UIActionSimpleACPIShutdown(this);
-    m_pool[UIActionIndexSelector_Simple_Machine_Close_PowerOff] = new UIActionSimplePowerOff(this);
 }
 
@@ -794,10 +795,9 @@
     /* 'Group' menu: */
     m_pool[UIActionIndexSelector_Menu_Group] = new UIActionMenuGroup(this);
+    m_pool[UIActionIndexSelector_Menu_Group_Close] = new UIActionMenuClose(this);
 
     /* 'Machine' menu: */
     m_pool[UIActionIndexSelector_Menu_Machine] = new UIActionMenuMachine(this);
-
-    /* 'Machine/Close' menu: */
-    m_pool[UIActionIndexSelector_Menu_Machine_Close] = new UIActionMenuMachineClose(this);
+    m_pool[UIActionIndexSelector_Menu_Machine_Close] = new UIActionMenuClose(this);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/UIActionPoolSelector.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/UIActionPoolSelector.h	(revision 42766)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/UIActionPoolSelector.h	(revision 42767)
@@ -39,4 +39,8 @@
     UIActionIndexSelector_Simple_Group_Remove,
     UIActionIndexSelector_Simple_Group_Sort,
+    UIActionIndexSelector_Menu_Group_Close,
+    UIActionIndexSelector_Simple_Group_Close_Save,
+    UIActionIndexSelector_Simple_Group_Close_ACPIShutdown,
+    UIActionIndexSelector_Simple_Group_Close_PowerOff,
 
     /* 'Machine' menu actions: */
@@ -46,4 +50,8 @@
     UIActionIndexSelector_Simple_Machine_Remove,
     UIActionIndexSelector_Simple_Machine_AddGroup,
+    UIActionIndexSelector_Menu_Machine_Close,
+    UIActionIndexSelector_Simple_Machine_Close_Save,
+    UIActionIndexSelector_Simple_Machine_Close_ACPIShutdown,
+    UIActionIndexSelector_Simple_Machine_Close_PowerOff,
 
     /* Common 'Group' / 'Machine' menu actions: */
@@ -58,10 +66,4 @@
     UIActionIndexSelector_Simple_Common_CreateShortcut,
     UIActionIndexSelector_Simple_Common_SortParent,
-
-    /* 'Machine/Close' menu actions: */
-    UIActionIndexSelector_Menu_Machine_Close,
-    UIActionIndexSelector_Simple_Machine_Close_Save,
-    UIActionIndexSelector_Simple_Machine_Close_ACPIShutdown,
-    UIActionIndexSelector_Simple_Machine_Close_PowerOff,
 
     /* Maximum index: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.cpp	(revision 42766)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.cpp	(revision 42767)
@@ -776,5 +776,5 @@
 }
 
-void UISelectorWindow::sltMachineCloseMenuAboutToShow()
+void UISelectorWindow::sltGroupCloseMenuAboutToShow()
 {
     /* Get selected items: */
@@ -782,5 +782,13 @@
     AssertMsgReturnVoid(!items.isEmpty(), ("At least one item should be selected!\n"));
 
-    m_pACPIShutdownAction->setEnabled(isActionEnabled(UIActionIndexSelector_Simple_Machine_Close_ACPIShutdown, items));
+    m_pGroupACPIShutdownAction->setEnabled(isActionEnabled(UIActionIndexSelector_Simple_Group_Close_ACPIShutdown, items));
+}
+void UISelectorWindow::sltMachineCloseMenuAboutToShow()
+{
+    /* Get selected items: */
+    QList<UIVMItem*> items = currentItems();
+    AssertMsgReturnVoid(!items.isEmpty(), ("At least one item should be selected!\n"));
+
+    m_pMachineACPIShutdownAction->setEnabled(isActionEnabled(UIActionIndexSelector_Simple_Machine_Close_ACPIShutdown, items));
 }
 
@@ -1071,5 +1079,10 @@
     menuBar()->addMenu(m_pFileMenu);
 
-    /* Prepare 'Close' menu: */
+    /* Prepare 'Group' / 'Close' menu: */
+    m_pGroupCloseMenuAction = gActionPool->action(UIActionIndexSelector_Menu_Group_Close);
+    m_pGroupCloseMenu = m_pGroupCloseMenuAction->menu();
+    prepareMenuGroupClose(m_pGroupCloseMenu);
+
+    /* Prepare 'Machine' / 'Close' menu: */
     m_pMachineCloseMenuAction = gActionPool->action(UIActionIndexSelector_Menu_Machine_Close);
     m_pMachineCloseMenu = m_pMachineCloseMenuAction->menu();
@@ -1175,5 +1188,5 @@
     pMenu->addAction(m_pAction_Common_PauseAndResume);
     pMenu->addAction(m_pAction_Common_Reset);
-    pMenu->addMenu(m_pMachineCloseMenu);
+    pMenu->addMenu(m_pGroupCloseMenu);
     pMenu->addSeparator();
     pMenu->addAction(m_pAction_Common_Discard);
@@ -1228,5 +1241,5 @@
 }
 
-void UISelectorWindow::prepareMenuMachineClose(QMenu *pMenu)
+void UISelectorWindow::prepareMenuGroupClose(QMenu *pMenu)
 {
     /* Do not touch if filled already: */
@@ -1234,11 +1247,26 @@
         return;
 
-    /* Populate Machine/Close-menu: */
-    m_pSaveAction = gActionPool->action(UIActionIndexSelector_Simple_Machine_Close_Save);
-    pMenu->addAction(m_pSaveAction);
-    m_pACPIShutdownAction = gActionPool->action(UIActionIndexSelector_Simple_Machine_Close_ACPIShutdown);
-    pMenu->addAction(m_pACPIShutdownAction);
-    m_pPowerOffAction = gActionPool->action(UIActionIndexSelector_Simple_Machine_Close_PowerOff);
-    pMenu->addAction(m_pPowerOffAction);
+    /* Populate 'Group' / 'Close' menu: */
+    m_pGroupSaveAction = gActionPool->action(UIActionIndexSelector_Simple_Group_Close_Save);
+    pMenu->addAction(m_pGroupSaveAction);
+    m_pGroupACPIShutdownAction = gActionPool->action(UIActionIndexSelector_Simple_Group_Close_ACPIShutdown);
+    pMenu->addAction(m_pGroupACPIShutdownAction);
+    m_pGroupPowerOffAction = gActionPool->action(UIActionIndexSelector_Simple_Group_Close_PowerOff);
+    pMenu->addAction(m_pGroupPowerOffAction);
+}
+
+void UISelectorWindow::prepareMenuMachineClose(QMenu *pMenu)
+{
+    /* Do not touch if filled already: */
+    if (!pMenu->isEmpty())
+        return;
+
+    /* Populate 'Machine' / 'Close' menu: */
+    m_pMachineSaveAction = gActionPool->action(UIActionIndexSelector_Simple_Machine_Close_Save);
+    pMenu->addAction(m_pMachineSaveAction);
+    m_pMachineACPIShutdownAction = gActionPool->action(UIActionIndexSelector_Simple_Machine_Close_ACPIShutdown);
+    pMenu->addAction(m_pMachineACPIShutdownAction);
+    m_pMachinePowerOffAction = gActionPool->action(UIActionIndexSelector_Simple_Machine_Close_PowerOff);
+    pMenu->addAction(m_pMachinePowerOffAction);
 }
 
@@ -1375,9 +1403,15 @@
     connect(m_pAction_Machine_Clone, SIGNAL(triggered()), this, SLOT(sltShowCloneMachineWizard()));
 
+    /* 'Group/Close' menu connections: */
+    connect(m_pGroupCloseMenu, SIGNAL(aboutToShow()), this, SLOT(sltGroupCloseMenuAboutToShow()));
+    connect(m_pGroupSaveAction, SIGNAL(triggered()), this, SLOT(sltPerformSaveAction()));
+    connect(m_pGroupACPIShutdownAction, SIGNAL(triggered()), this, SLOT(sltPerformACPIShutdownAction()));
+    connect(m_pGroupPowerOffAction, SIGNAL(triggered()), this, SLOT(sltPerformPowerOffAction()));
+
     /* 'Machine/Close' menu connections: */
     connect(m_pMachineCloseMenu, SIGNAL(aboutToShow()), this, SLOT(sltMachineCloseMenuAboutToShow()));
-    connect(m_pSaveAction, SIGNAL(triggered()), this, SLOT(sltPerformSaveAction()));
-    connect(m_pACPIShutdownAction, SIGNAL(triggered()), this, SLOT(sltPerformACPIShutdownAction()));
-    connect(m_pPowerOffAction, SIGNAL(triggered()), this, SLOT(sltPerformPowerOffAction()));
+    connect(m_pMachineSaveAction, SIGNAL(triggered()), this, SLOT(sltPerformSaveAction()));
+    connect(m_pMachineACPIShutdownAction, SIGNAL(triggered()), this, SLOT(sltPerformACPIShutdownAction()));
+    connect(m_pMachinePowerOffAction, SIGNAL(triggered()), this, SLOT(sltPerformPowerOffAction()));
 
     /* 'Help' menu connections: */
@@ -1575,9 +1609,15 @@
     m_pAction_Common_SortParent->setEnabled(isActionEnabled(UIActionIndexSelector_Simple_Common_SortParent, items));
 
+    /* Enable/disable group-close actions: */
+    m_pGroupCloseMenuAction->setEnabled(isActionEnabled(UIActionIndexSelector_Menu_Group_Close, items));
+    m_pGroupSaveAction->setEnabled(isActionEnabled(UIActionIndexSelector_Simple_Group_Close_Save, items));
+    m_pGroupACPIShutdownAction->setEnabled(isActionEnabled(UIActionIndexSelector_Simple_Group_Close_ACPIShutdown, items));
+    m_pGroupPowerOffAction->setEnabled(isActionEnabled(UIActionIndexSelector_Simple_Group_Close_PowerOff, items));
+
     /* Enable/disable machine-close actions: */
     m_pMachineCloseMenuAction->setEnabled(isActionEnabled(UIActionIndexSelector_Menu_Machine_Close, items));
-    m_pSaveAction->setEnabled(isActionEnabled(UIActionIndexSelector_Simple_Machine_Close_Save, items));
-    m_pACPIShutdownAction->setEnabled(isActionEnabled(UIActionIndexSelector_Simple_Machine_Close_ACPIShutdown, items));
-    m_pPowerOffAction->setEnabled(isActionEnabled(UIActionIndexSelector_Simple_Machine_Close_PowerOff, items));
+    m_pMachineSaveAction->setEnabled(isActionEnabled(UIActionIndexSelector_Simple_Machine_Close_Save, items));
+    m_pMachineACPIShutdownAction->setEnabled(isActionEnabled(UIActionIndexSelector_Simple_Machine_Close_ACPIShutdown, items));
+    m_pMachinePowerOffAction->setEnabled(isActionEnabled(UIActionIndexSelector_Simple_Machine_Close_PowerOff, items));
 
     /* Start/Show action is deremined by 1st item: */
@@ -1688,12 +1728,15 @@
             return isAtLeastOneItemSupportsShortcuts(items);
         }
+        case UIActionIndexSelector_Menu_Group_Close:
         case UIActionIndexSelector_Menu_Machine_Close:
         {
             return isAtLeastOneItemStarted(items);
         }
+        case UIActionIndexSelector_Simple_Group_Close_Save:
         case UIActionIndexSelector_Simple_Machine_Close_Save:
         {
             return isActionEnabled(UIActionIndexSelector_Menu_Machine_Close, items);
         }
+        case UIActionIndexSelector_Simple_Group_Close_ACPIShutdown:
         case UIActionIndexSelector_Simple_Machine_Close_ACPIShutdown:
         {
@@ -1701,4 +1744,5 @@
                    isAtLeastOneItemAbleToShutdown(items);
         }
+        case UIActionIndexSelector_Simple_Group_Close_PowerOff:
         case UIActionIndexSelector_Simple_Machine_Close_PowerOff:
         {
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.h	(revision 42766)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.h	(revision 42767)
@@ -100,4 +100,5 @@
     void sltShowMachineInFileManager();
     void sltPerformCreateShortcutAction();
+    void sltGroupCloseMenuAboutToShow();
     void sltMachineCloseMenuAboutToShow();
 
@@ -130,4 +131,5 @@
     void prepareMenuGroup(QMenu *pMenu);
     void prepareMenuMachine(QMenu *pMenu);
+    void prepareMenuGroupClose(QMenu *pMenu);
     void prepareMenuMachineClose(QMenu *pMenu);
     void prepareMenuHelp(QMenu *pMenu);
@@ -212,4 +214,10 @@
     UIAction *m_pAction_Group_Remove;
     UIAction *m_pAction_Group_Sort;
+    /* 'Group / Close' menu action pointers: */
+    UIAction *m_pGroupCloseMenuAction;
+    QMenu *m_pGroupCloseMenu;
+    UIAction *m_pGroupSaveAction;
+    UIAction *m_pGroupACPIShutdownAction;
+    UIAction *m_pGroupPowerOffAction;
 
     /* 'Machine' menu action pointers: */
@@ -221,11 +229,10 @@
     UIAction *m_pAction_Machine_Remove;
     UIAction *m_pAction_Machine_AddGroup;
-
     /* 'Machine / Close' menu action pointers: */
     UIAction *m_pMachineCloseMenuAction;
     QMenu *m_pMachineCloseMenu;
-    UIAction *m_pSaveAction;
-    UIAction *m_pACPIShutdownAction;
-    UIAction *m_pPowerOffAction;
+    UIAction *m_pMachineSaveAction;
+    UIAction *m_pMachineACPIShutdownAction;
+    UIAction *m_pMachinePowerOffAction;
 
     /* 'Help' menu action pointers: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp	(revision 42766)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp	(revision 42767)
@@ -906,5 +906,5 @@
     m_pContextMenuGroup->addAction(gActionPool->action(UIActionIndexSelector_Toggle_Common_PauseAndResume));
     m_pContextMenuGroup->addAction(gActionPool->action(UIActionIndexSelector_Simple_Common_Reset));
-    m_pContextMenuGroup->addMenu(gActionPool->action(UIActionIndexSelector_Menu_Machine_Close)->menu());
+    m_pContextMenuGroup->addMenu(gActionPool->action(UIActionIndexSelector_Menu_Group_Close)->menu());
     m_pContextMenuGroup->addSeparator();
     m_pContextMenuGroup->addAction(gActionPool->action(UIActionIndexSelector_Simple_Common_Discard));