Index: /trunk/src/VBox/Additions/linux/drm/vboxvideo_crtc.c
===================================================================
--- /trunk/src/VBox/Additions/linux/drm/vboxvideo_crtc.c	(revision 42783)
+++ /trunk/src/VBox/Additions/linux/drm/vboxvideo_crtc.c	(revision 42784)
@@ -44,5 +44,5 @@
 
 #include <linux/version.h>
-#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,33)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 33)
 
 #include <VBox/VBoxVideoGuest.h>
Index: /trunk/src/VBox/Additions/linux/drm/vboxvideo_dac.c
===================================================================
--- /trunk/src/VBox/Additions/linux/drm/vboxvideo_dac.c	(revision 42783)
+++ /trunk/src/VBox/Additions/linux/drm/vboxvideo_dac.c	(revision 42784)
@@ -44,5 +44,5 @@
 
 #include <linux/version.h>
-#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,33)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 33)
 
 #include "vboxvideo_drv.h"
Index: /trunk/src/VBox/Additions/linux/drm/vboxvideo_drm.c
===================================================================
--- /trunk/src/VBox/Additions/linux/drm/vboxvideo_drm.c	(revision 42783)
+++ /trunk/src/VBox/Additions/linux/drm/vboxvideo_drm.c	(revision 42784)
@@ -51,5 +51,5 @@
 
 #include <linux/version.h>
-#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,33)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 33)
 # include <generated/autoconf.h>
 #else
@@ -83,5 +83,5 @@
 int vboxvideo_driver_load(struct drm_device * dev, unsigned long flags)
 {
-# if LINUX_VERSION_CODE >= KERNEL_VERSION (2, 6, 28)
+# if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 28)
     return drm_vblank_init(dev, 1);
 #else
@@ -89,5 +89,5 @@
 #endif
 }
-#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,3,0) || defined(DRM_RHEL63)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(3, 3, 0) || defined(DRM_RHEL63)
 /* since linux-3.3.0-rc1 drm_driver::fops is pointer */
 static struct file_operations driver_fops =
@@ -107,11 +107,13 @@
     /* .driver_features = DRIVER_USE_MTRR, */
     .load = vboxvideo_driver_load,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(3, 6, 0)
     .reclaim_buffers = drm_core_reclaim_buffers,
+#endif
     /* As of Linux 2.6.37, always the internal functions are used. */
-#if LINUX_VERSION_CODE < KERNEL_VERSION (2, 6, 37) && !defined(DRM_RHEL61)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37) && !defined(DRM_RHEL61)
     .get_map_ofs = drm_core_get_map_ofs,
     .get_reg_ofs = drm_core_get_reg_ofs,
 #endif
-# if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0) && !defined(DRM_RHEL63)
+# if LINUX_VERSION_CODE < KERNEL_VERSION(3, 3, 0) && !defined(DRM_RHEL63)
     .fops =
     {
@@ -121,5 +123,5 @@
         /* This was changed with Linux 2.6.33 but Fedora backported this
          * change to their 2.6.32 kernel. */
-#if defined(DRM_UNLOCKED) || LINUX_VERSION_CODE >= KERNEL_VERSION (2, 6, 33)
+#if defined(DRM_UNLOCKED) || LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 33)
         .unlocked_ioctl = drm_ioctl,
 #else
@@ -130,8 +132,8 @@
         .fasync = drm_fasync,
     },
-#else /* LINUX_VERSION_CODE >= KERNEL_VERSION(3,3,0) || defined(DRM_RHEL63) */
+#else /* LINUX_VERSION_CODE >= KERNEL_VERSION(3, 3, 0) || defined(DRM_RHEL63) */
     .fops = &driver_fops,
 #endif
-#if LINUX_VERSION_CODE < KERNEL_VERSION (2, 6, 39) && !defined(DRM_RHEL61)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 39) && !defined(DRM_RHEL61)
     .pci_driver =
     {
@@ -148,5 +150,5 @@
 };
 
-#if LINUX_VERSION_CODE >= KERNEL_VERSION (2, 6, 39) || defined(DRM_RHEL61)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 39) || defined(DRM_RHEL61)
 static struct pci_driver pci_driver =
 {
@@ -158,5 +160,5 @@
 static int __init vboxvideo_init(void)
 {
-#if LINUX_VERSION_CODE < KERNEL_VERSION (2, 6, 39) && !defined(DRM_RHEL61)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 39) && !defined(DRM_RHEL61)
     return drm_init(&driver);
 #else
@@ -167,5 +169,5 @@
 static void __exit vboxvideo_exit(void)
 {
-#if LINUX_VERSION_CODE < KERNEL_VERSION (2, 6, 39) && !defined(DRM_RHEL61)
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 39) && !defined(DRM_RHEL61)
     drm_exit(&driver);
 #else
Index: /trunk/src/VBox/Additions/linux/drm/vboxvideo_vga.c
===================================================================
--- /trunk/src/VBox/Additions/linux/drm/vboxvideo_vga.c	(revision 42783)
+++ /trunk/src/VBox/Additions/linux/drm/vboxvideo_vga.c	(revision 42784)
@@ -44,5 +44,5 @@
 
 #include <linux/version.h>
-#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,33)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 33)
 
 #include "vboxvideo_drv.h"
Index: /trunk/src/VBox/HostDrivers/Support/SUPDrvInternal.h
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/SUPDrvInternal.h	(revision 42783)
+++ /trunk/src/VBox/HostDrivers/Support/SUPDrvInternal.h	(revision 42784)
@@ -79,5 +79,5 @@
 #elif defined(RT_OS_LINUX)
 #   include <linux/version.h>
-#   if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,33)
+#   if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 33)
 #    include <generated/autoconf.h>
 #   else
Index: /trunk/src/VBox/Runtime/include/internal/iprt.h
===================================================================
--- /trunk/src/VBox/Runtime/include/internal/iprt.h	(revision 42783)
+++ /trunk/src/VBox/Runtime/include/internal/iprt.h	(revision 42784)
@@ -41,5 +41,5 @@
 # define bool linux_bool /* see r0drv/linux/the-linux-kernel.h */
 # include <linux/version.h>
-# if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,33)
+# if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 33)
 #  include <generated/autoconf.h>
 # else
Index: /trunk/src/VBox/Runtime/r0drv/linux/the-linux-kernel.h
===================================================================
--- /trunk/src/VBox/Runtime/r0drv/linux/the-linux-kernel.h	(revision 42783)
+++ /trunk/src/VBox/Runtime/r0drv/linux/the-linux-kernel.h	(revision 42784)
@@ -36,5 +36,5 @@
 
 #include <linux/version.h>
-#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,33)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 33)
 # include <generated/autoconf.h>
 #else
Index: /trunk/src/VBox/Runtime/r0drv/linux/thread2-r0drv-linux.c
===================================================================
--- /trunk/src/VBox/Runtime/r0drv/linux/thread2-r0drv-linux.c	(revision 42783)
+++ /trunk/src/VBox/Runtime/r0drv/linux/thread2-r0drv-linux.c	(revision 42784)
@@ -52,5 +52,5 @@
 DECLHIDDEN(int) rtThreadNativeSetPriority(PRTTHREADINT pThread, RTTHREADTYPE enmType)
 {
-#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,11)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 11)
     /* See comment near MAX_RT_PRIO in linux/sched.h for details on
        sched_priority. */